'use strict';
function iq_canvas(canvas_id, opts){
    // HACK: really nasty copy paste
    opts = obj_extend(opts, {
        trace_bg_color: 'black',
        bg_color: '#231f20',
        bottom_font_color: '#fff',
        grid_color: '#aaa',
        trace_color: '#ff0',
        crosshair_color: '#289b7d',
        amplitude_units: 'dBm',
        font_size: 14,
        label_pad: 5,
        num_divs: 10,
        limit_color: 'rgb(0, 177, 235)',
        active_limit_color: 'rgb(98, 187, 70)',
    });

    var base = base_canvas(canvas_id, opts);

    base.layers.iq_scatter = layer();
    base.layers.frame = layer();

    function draw_frame(ctx) {
        ctx.fillStyle = opts.grid_color;
        ctx.fillRect(0, 0, ctx.width, 1);
        ctx.fillRect(0, 0, 1, ctx.height);
        ctx.fillRect(0, ctx.height - 1, ctx.width, 1);
        ctx.fillRect(ctx.width - 1, 0, 1, ctx.height);
    }

    base._resize_other_elements = function(display){
        {
            var outer_w = display.graphics_area().w;
            var outer_h = display.graphics_area().h;

            var min_dimension = 0.9 * Math.min(outer_w, outer_h);
            var w = min_dimension;
            var h = min_dimension;
            var x = display.graphics_area().x + (outer_w/2) - (w/2);
            var y = base.layers.metadata.rect().y + (outer_h/2) - (h/2);

            base.layers.frame.resize(x,y,w,h);
            base.layers.iq_scatter.resize(x, y, w -1 , h -1 );
        }
    }


    base._draw_other_elements = function(args){
        args = obj_extend(args, {
            points: [],
            ylabels: [],
            messages: [],
            metadata: {},
            model_number: '',
            unit_name:'',
            unit_in_use_message:'',
            gps: 'No GPS Fix',
            time: format_datetime(new Date()),
            display: {  },
        });

        base.layers.frame.draw(function(ctx){
            ctx.fillStyle = opts.trace_bg_color;
            ctx.fillRect(0, 0, base.element.width, base.element.height);
            draw_frame(ctx);
        });


        // HACK: reuse the trace layer until the layers are mover out of the base
        base.layers.iq_scatter.draw(function (ctx) {

            draw_scatter_plot(ctx, opts, args.points);

            ctx.restore();
            ctx.save();
        });
    };

    base._compose_other_elements = function(ctx)
    {
        base.layers.frame.compose_onto(ctx);
        base.layers.iq_scatter.compose_onto(ctx);
    }

    return base;
}
