function draw_scatter_plot(ctx, opts, points, scale){
    if (points.length == 0){
        return;
    }

    var pointSize = 2;
    // complete auto scale
    var maxes = points.reduce(function(a,b) {
        return [Math.max(a[0], b[0]), Math.max(a[1], b[1])];
    });

    var mins = points.reduce(function(a,b) {
        return [Math.min(a[0], b[0]), Math.min(a[1], b[1])];
    });

    //hacks to get rid of distortion and center for iq data
    // ideally the scaleing would be more flexible

    var vals = maxes.concat(mins);
    var maxValue = vals.reduce(function(a,b){
        return Math.max(Math.abs(a), Math.abs(b));
    });

    mins = [-maxValue, -maxValue];
    maxes= [maxValue, maxValue];
    // end hacks


    // scale to the context height and width
    function rescale(point){
        function rescaleItem(point, index){
            var scales = [ctx.width -(2*pointSize), ctx.height - (2* pointSize)];
            return ((point[index] - mins[index])/(maxes[index] - mins[index]))*scales[index]+ pointSize;
        };
        return [rescaleItem(point,0), rescaleItem(point,1)];
    }

    ctx.fillStyle = opts.trace_color;

    function draw_point(point){
        point = rescale(point);
        ctx.fillRect( point[0], ctx.height -point[1],pointSize,pointSize)
    };

    points.forEach(draw_point);
};