'use strict';

function styling(opts){

    function normal_font(size_factor) {
        return (opts.font_size * (size_factor || 1)) + 'px sans-serif';
    }

    function bold_font(size_factor) {
        return 'bold ' + normal_font(size_factor);
    }

    function outlined_text(ctx, text, x, y, w) {
        ctx.strokeStyle = opts.trace_bg_color;
        ctx.lineWidth = 3;
        w = w || 9e9;

        ctx.strokeText(text, x, y, w);
        ctx.fillText(text, x, y, w);
    }

    return{
        normal_font: normal_font,
        bold_font: bold_font,
        outlined_text: outlined_text,
    }
}
