function Cursor() {
    var enabled = false;

    function get_coords(mouse, trace_data) {
        var raw_trace_data = trace_data.data();
        if (!enabled || !mouse || !raw_trace_data) {
            return null;
        }

        var amp = '';
        var num_points = raw_trace_data.length - 1;
        var snapped_x = Math.round(mouse.x * num_points) / num_points;
        var freq = trace_data.frequency.from_relative(snapped_x);

        if (mouse.x >= 0 && mouse.x <= 1) {
            var index = Math.round(raw_trace_data.length * mouse.x);
            index = Math.max(0, Math.min(num_points, index));
            if (!isNaN(raw_trace_data[index])) {
                amp = format_amplitude(raw_trace_data[index], trace_data.units());
            }
        }

        return {
            x: snapped_x,
            freq: format_freq(freq),
            ampl: amp
        };
    }

    return {
        get: get_coords,
        focus: function () {
            enabled = true;
        },
        blur: function () {
            enabled = false;
        },
    }
}
