'use strict';

(function feature_detection() {
    try {
        var features = [
            window.Uint8ClampedArray,
            window.requestAnimationFrame,
            window.atob,
            window.btoa,
            window.JSON,
            window.WebSocket,
            document.createElement('canvas').getContext('2d'),
            Array.prototype.reduce,
            Array.prototype.filter,
            Array.prototype.map,
            Math.max, Math.min, Math.ceil, Math.floor, Math.round,
            Math.abs, Math.log,
        ];
    }
    catch (e) {
        $('body > *').hide();
        $('#bad-browser').show();
        throw 'bad browser';
    }

    for (var i = 0; i < features.length; i++) {
        if (typeof features[i] === 'undefined') {
            $('body > *').hide();
            $('#bad-browser').show();
            throw 'bad browser';
        }
    }

    // Polyfills for IE
    Math.trunc = Math.trunc || function(x) {
        return x < 0 ? Math.ceil(x) : Math.floor(x);
    };

    Math.sign = Math.sign || function sign(x) {
        return x > 0 ? 1 : -1;
    };

    Math.log10 = Math.log10 || function log10(x) {
        return Math.log(x) / Math.LN10;
    };

    String.prototype.includes = String.prototype.includes || function (search, start) {
        'use strict';
        if (typeof start !== 'number') {
            start = 0;
        }

        if (start + search.length > this.length) {
            return false;
        } else {
            return this.indexOf(search, start) !== -1;
        }
    };

    // If the stylesheet is not being interpreted, explicitly hide
    // the "bad browser" message to avoid misleading the user. If
    // we've made it this far, then the browser is actually OK.
    $('#bad-browser').hide();
})();
