function Limits(spectrum, trace_data, scpi) {
    var $table_div = $('#limit-table');
    var table = limit_table(spectrum, trace_data);
    var client = scpi.client;
    table.focus();

    function get_drawables() {
        var maybe_relative = table.get()
        var center_freq = trace_data.frequency.center;
        var ref_level = trace_data.ref_level();

        return {
            active_index: table.active_index(),
            segments: maybe_relative.segments.map(function (segment) {
                var start = segment.frequency.start;
                var stop = segment.frequency.stop;
                var amp = segment.amplitude.value;

                if (maybe_relative.frequencyRelative) {
                    start += center_freq;
                    stop += center_freq;
                }

                if (maybe_relative.amplitudeRelative) {
                    amp += ref_level;
                }

                return {
                    start: trace_data.frequency.to_relative(start),
                    stop: trace_data.frequency.to_relative(stop),
                    amp: trace_data.normalize(amp),
                };
            }),
        };
    }

    // Get the initial state
    client.onconnect(function () {
        client.send('spectrum-limits', table.initialize);
    });

    
    var autosave_timer;

    $table_div.on('initialized', function () {
        $table_div.on('change', function () {
            clearTimeout(autosave_timer);
            autosave_timer = setTimeout(function() {
	            client.send('spectrum-limits', table.get(), function (msg) {
        	        console.log(msg);
                    });
            }, 1000);
        });
    });

    return {
        get_drawables: get_drawables,
        focus: table.focus,
        blur: table.blur,
    };
}
