function TraceStatus(trace_data) {
    function array_any(arr, key) {
        key = key || function (b) { return !!b; };
        for (var i = 0, len = arr.length; i < len; i++) {
            if (key(arr[i])) return true;
        }
        return false;
    }

    var status_bits_meta = [
        { mask: 0x1, style: '#f33', label: 'ADC Overrange' },
        { mask: 0x2, style: '#f33', label: 'Power Saturated' },
        { mask: 0x4, style: '#f3f', label: 'SLO Lock Fail' },
        { mask: 0x8, style: '#f1f', label: 'LO1 Lock Fail' },
        { mask: 0x10, style: '#f1f', label: 'LO2 Lock Fail' },
        { mask: 0x20, style: '#f13', label: 'TG Lock Fail' },
    ];

    function get_messages() {
        var ret = [];
        if (array_any(trace_data.stale_mask())) {
            ret.push({
                label: 'Trace data invalid',
                style: 'orange'
            })
        }

        status_bits_meta.map(function (meta) {
            var is_set = array_any(trace_data.status_mask(), function (stat) {
                return stat & meta.mask;
            });
            if (is_set) {
                ret.push({ label: meta.label, style: meta.style });
            }
        });

        return ret;
    }

    function get_colors() {
        return trace_data.status_mask().map(function (stat) {
            for (var i = 0, len = status_bits_meta.length; i < len; i++) {
                var meta = status_bits_meta[i];
                if (stat & meta.mask) {
                    return meta.style;
                }
            }
            return undefined;
        });
    }

    return {
        get_messages: get_messages,
        get_colors: get_colors,
    };
}
