'use strict';

function clamp(val, a, b) {
    var max = Math.max, min = Math.min;
    return min(max(a, b), max(min(a, b), val));
};

function array_max(arr) {
    function max(a, b) { return a > b ? a : b; }
    return arr.reduce(max, arr[0]);
};

function array_min(arr) {
    function min(a, b) { return a < b ? a : b; }
    return arr.reduce(min, arr[0]);
};

function array_any(arr, key) {
    key = key || function (b) { return !!b; };
    for (var i = 0, len = arr.length; i < len; i++) {
        if (key(arr[i])) return true;
    }
    return false;
};

function modal_overlay(selector) {
    var el = $(selector);
    var dismiss = el.find('.dismiss');
    dismiss.attr('href', 'javascript: void(0);');
    dismiss.on('click', function () {
        methods.hide();
    });

    var methods = {
        show: function () {
            el.addClass('show');
        },
        hide: function () {
            el.removeClass('show');
        }
    }

    return methods;
};

function call(fn) { return fn(); };

function obj_extend(ext, base) {
    var ret = {};

    for (var key in base) ret[key] = base[key];
    for (var key in ext)  ret[key] = ext[key];

    return ret;
}